Overlays are used for displaying messages over the top of the grid. There are two built-in overlays: loading and no-rows.
This page documents the legacy approach to handling overlays. For the latest documentation, see Overlays Overview.
Loading overlay Copy Link
Show or hide the loading overlay by setting the loading property to true or false.
Show or hide the loading UI. true: the loading overlay is shown, or skeleton rows if loadingRows is enabled (Client-Side Row Model only). false: the loading UI is hidden. undefined: the grid will automatically show the loading overlay until rowData and columnDefs are provided. (Client Side Row Model only) |
The loading overlay takes precedence over the no-rows overlay and is not dependent of the state of rowData.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
let gridApi: GridApi<IAthlete>;
const gridOptions: GridOptions<IAthlete> = {
loading: true,
columnDefs: [{ field: "athlete" }, { field: "country" }],
};
function setLoading(value: boolean) {
gridApi!.setGridOption("loading", value);
}
function onBtnClearRowData() {
gridApi!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).setLoading = setLoading;
(<any>window).onBtnClearRowData = onBtnClearRowData;
(<any>window).onBtnSetRowData = onBtnSetRowData;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
<div class="example-wrapper">
<div>
<label class="checkbox">
<input type="checkbox" checked onchange="setLoading(event.currentTarget.checked)" />
loading
</label>
<button onclick="onBtnClearRowData()">Clear rowData</button>
<button onclick="onBtnSetRowData()">Set rowData</button>
</div>
<div id="myGrid"></div>
</div>
No rows overlay Copy Link
When rowData is set to an empty array [], the grid automatically displays the no-rows overlay. The no-rows overlay can also be programmatically shown / hidden via the grid API.
It is recommended to use the Active Overlay to manually display an overlay.
Show the no-rows overlay. If loading is true, this will not do anything.setGridOption('activeOverlay', 'agNoRowsOverlay') . |
Hide the no-rows overlay if it is showing. setGridOption('activeOverlay', undefined) . |
The automatic displaying of the no-rows overlay can be suppressed by setting suppressNoRowsOverlay to true.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
let gridApi: GridApi<IAthlete>;
const gridOptions: GridOptions<IAthlete> = {
rowData: [],
columnDefs: [{ field: "athlete" }, { field: "country" }],
};
function onBtnClearRowData() {
gridApi!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtnClearRowData = onBtnClearRowData;
(<any>window).onBtnSetRowData = onBtnSetRowData;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
<div class="example-wrapper">
<div>
<button onclick="onBtnClearRowData()">Clear rowData</button>
<button onclick="onBtnSetRowData()">Set rowData</button>
</div>
<div id="myGrid"></div>
</div>
Initial loading overlay Copy Link
If loading is not explicitly defined, the grid will automatically show the loading overlay until both rowData and columnDefs are provided with a non-null value for the first time. This behaviour can be suppressed by initialising the grid with an appropriate loading state.
Customisation Copy Link
Overlays can be customised by providing either a HTML string or custom component via grid properties.
Custom Loading Overlay Copy Link
The loading overlay can be customised via the grid properties overlayLoadingTemplate or loadingOverlayComponent and loadingOverlayComponentParams.
Provide a HTML string to override the default loading overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom loading overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the loading overlay component. overlayComponentParams |
Implement this interface to provide a custom overlay when data is being loaded.
interface ILoadingOverlayComp<TData = any, TContext = any> {
// Return the DOM element of your component, this is what the grid puts into the DOM
getGui(): HTMLElement;
// Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
destroy?(): void;
// The init(params) method is called on the component once.
init?(params: TParams): AgPromise<void> | void;
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom loading overlay component customised via parameters.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CustomLoadingOverlay } from "./customLoadingOverlay";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
interface IAthlete {
athlete: string;
country: string;
}
const columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
const rowData: IAthlete[] = [
{ athlete: "Michael Phelps", country: "United States" },
{ athlete: "Natalie Coughlin", country: "United States" },
{ athlete: "Aleksey Nemov", country: "Russia" },
{ athlete: "Alicia Coutts", country: "Australia" },
];
let gridApi: GridApi<IAthlete>;
const gridOptions: GridOptions<IAthlete> = {
defaultColDef: {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
},
loading: true,
columnDefs: columnDefs,
rowData,
loadingOverlayComponent: CustomLoadingOverlay,
loadingOverlayComponentParams: {
loadingMessage: "One moment please...",
},
};
function setLoading(value: boolean) {
gridApi!.setGridOption("loading", value);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).setLoading = setLoading;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
label.checkbox {
display: inline-block;
user-select: none;
margin: 20px;
}
.fa-hourglass-half {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import type { ILoadingOverlayComp, ILoadingOverlayParams } from 'ag-grid-community';
type CustomLoadingOverlayParams = ILoadingOverlayParams & { loadingMessage: string };
export class CustomLoadingOverlay implements ILoadingOverlayComp {
eGui!: HTMLElement;
init(params: CustomLoadingOverlayParams) {
this.eGui = document.createElement('div');
this.refresh(params);
}
getGui() {
return this.eGui;
}
refresh(params: CustomLoadingOverlayParams): void {
this.eGui.innerHTML = `<div class="overlay-loading-center" role="presentation">
<div role="presentation" style="height:100px; width:100px; background: url(https://www.ag-grid.com/images/ag-grid-loading-spinner.svg) center / contain no-repeat; margin: 0 auto;"></div>
<div aria-live="polite" aria-atomic="true">${params.loadingMessage}</div>
</div>`;
}
}
<div class="example-wrapper">
<div>
<label class="checkbox">
<input type="checkbox" checked onchange="setLoading(event.currentTarget.checked)" />
loading
</label>
</div>
<div id="myGrid"></div>
</div>
Custom No Rows Overlay Copy Link
The no-rows overlay can be customised via the grid properties overlayNoRowsTemplate or noRowsOverlayComponent and noRowsOverlayComponentParams.
Provide a HTML string to override the default no-rows overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom no-rows overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the no-rows overlay component. overlayComponentParams |
Implement this interface to provide a custom overlay when no-rows loaded.
interface INoRowsOverlayComp<TData = any, TContext = any> {
// Return the DOM element of your component, this is what the grid puts into the DOM
getGui(): HTMLElement;
// Gets called once by grid when the component is being removed; if your component needs to do any cleanup, do it here
destroy?(): void;
// The init(params) method is called on the component once.
init?(params: TParams): AgPromise<void> | void;
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom no-rows overlay component customised via parameters.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { CustomNoRowsOverlay } from "./customNoRowsOverlay";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
interface IAthlete {
athlete: string;
country: string;
}
const columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
let gridApi: GridApi<IAthlete>;
const gridOptions: GridOptions<IAthlete> = {
defaultColDef: {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
},
columnDefs: columnDefs,
rowData: [],
noRowsOverlayComponent: CustomNoRowsOverlay,
noRowsOverlayComponentParams: {
noRowsMessageFunc: () =>
"No rows found at: " + new Date().toLocaleTimeString(),
},
};
function onBtnClearRowData() {
gridApi!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).onBtnClearRowData = onBtnClearRowData;
(<any>window).onBtnSetRowData = onBtnSetRowData;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
.fa-frown {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import type { INoRowsOverlayComp, INoRowsOverlayParams } from 'ag-grid-community';
type CustomNoRowsOverlayParams = INoRowsOverlayParams & { noRowsMessageFunc: () => string };
export class CustomNoRowsOverlay implements INoRowsOverlayComp {
eGui!: HTMLElement;
init(params: CustomNoRowsOverlayParams) {
this.eGui = document.createElement('div');
this.refresh(params);
}
getGui() {
return this.eGui;
}
refresh(params: CustomNoRowsOverlayParams): void {
this.eGui.innerHTML = `
<div role="presentation" class="overlay-loading-center" style="background-color: #b4bebe;">
<i class="far fa-frown" aria-live="polite" aria-atomic="true"> ${params.noRowsMessageFunc()} </i>
</div>
`;
}
}
<div class="example-wrapper">
<div>
<button onclick="onBtnClearRowData()">Clear rowData</button>
<button onclick="onBtnSetRowData()">Set rowData</button>
</div>
<div id="myGrid"></div>
</div>

Overlays are used for displaying messages over the top of the grid. There are two built-in overlays: loading and no-rows.
This page documents the legacy approach to handling overlays. For the latest documentation, see Overlays Overview.
Loading overlay Copy Link
Show or hide the loading overlay by setting the loading property to true or false.
Show or hide the loading UI. true: the loading overlay is shown, or skeleton rows if loadingRows is enabled (Client-Side Row Model only). false: the loading UI is hidden. undefined: the grid will automatically show the loading overlay until rowData and columnDefs are provided. (Client Side Row Model only) |
The loading overlay takes precedence over the no-rows overlay and is not dependent of the state of rowData.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div>
<label class="checkbox">
<input
type="checkbox"
checked=""
(change)="setLoading($event.currentTarget.checked)"
/>
loading
</label>
<button (click)="onBtnClearRowData()">Clear rowData</button>
<button (click)="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[loading]="true"
[columnDefs]="columnDefs"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IAthlete>;
columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
rowData!: IAthlete[];
setLoading(value: boolean) {
this.gridApi.setGridOption("loading", value);
}
onBtnClearRowData() {
this.gridApi.setGridOption("rowData", []);
}
onBtnSetRowData() {
this.gridApi.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
onGridReady(params: GridReadyEvent<IAthlete>) {
this.gridApi = params.api;
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
No rows overlay Copy Link
When rowData is set to an empty array [], the grid automatically displays the no-rows overlay. The no-rows overlay can also be programmatically shown / hidden via the grid API.
It is recommended to use the Active Overlay to manually display an overlay.
Show the no-rows overlay. If loading is true, this will not do anything.setGridOption('activeOverlay', 'agNoRowsOverlay') . |
Hide the no-rows overlay if it is showing. setGridOption('activeOverlay', undefined) . |
The automatic displaying of the no-rows overlay can be suppressed by setting suppressNoRowsOverlay to true.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div>
<button (click)="onBtnClearRowData()">Clear rowData</button>
<button (click)="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[rowData]="rowData"
[columnDefs]="columnDefs"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IAthlete>;
rowData: IAthlete[] | null = [];
columnDefs: ColDef[] = [{ field: "athlete" }, { field: "country" }];
onBtnClearRowData() {
this.gridApi.setGridOption("rowData", []);
}
onBtnSetRowData() {
this.gridApi.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
onGridReady(params: GridReadyEvent<IAthlete>) {
this.gridApi = params.api;
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Initial loading overlay Copy Link
If loading is not explicitly defined, the grid will automatically show the loading overlay until both rowData and columnDefs are provided with a non-null value for the first time. This behaviour can be suppressed by initialising the grid with an appropriate loading state.
Customisation Copy Link
Overlays can be customised by providing either a HTML string or custom component via grid properties.
Custom Loading Overlay Copy Link
The loading overlay can be customised via the grid properties overlayLoadingTemplate or loadingOverlayComponent and loadingOverlayComponentParams.
Provide a HTML string to override the default loading overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom loading overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the loading overlay component. overlayComponentParams |
Implement this interface to provide a custom overlay when data is being loaded.
interface ILoadingOverlayAngularComp {
// Mandatory - Params for rendering this component.
agInit(params: ILoadingOverlayParams): void;
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom loading overlay component customised via parameters.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
import { CustomLoadingOverlay } from "./custom-loading-overlay.component";
interface IAthlete {
athlete: string;
country: string;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomLoadingOverlay],
template: `<div class="example-wrapper">
<div>
<label class="checkbox">
<input
type="checkbox"
checked=""
(change)="setLoading($event.currentTarget.checked)"
/>
loading
</label>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[rowData]="rowData"
[defaultColDef]="defaultColDef"
[loading]="true"
[loadingOverlayComponent]="loadingOverlayComponent"
[loadingOverlayComponentParams]="loadingOverlayComponentParams"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IAthlete>;
columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
rowData: IAthlete[] | null = [
{ athlete: "Michael Phelps", country: "United States" },
{ athlete: "Natalie Coughlin", country: "United States" },
{ athlete: "Aleksey Nemov", country: "Russia" },
{ athlete: "Alicia Coutts", country: "Australia" },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
loadingOverlayComponent: any = CustomLoadingOverlay;
loadingOverlayComponentParams: any = {
loadingMessage: "One moment please...",
};
setLoading(value: boolean) {
this.gridApi.setGridOption("loading", value);
}
onGridReady(params: GridReadyEvent<IAthlete>) {
this.gridApi = params.api;
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
label.checkbox {
display: inline-block;
user-select: none;
margin: 20px;
}
.fa-hourglass-half {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ILoadingOverlayAngularComp } from 'ag-grid-angular';
import type { ILoadingOverlayParams } from 'ag-grid-community';
type CustomLoadingOverlayParams = ILoadingOverlayParams & { loadingMessage: string };
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div class="overlay-loading-center" role="presentation">
<div
role="presentation"
style="width: 100px; height: 100px; background: url(https://www.ag-grid.com/images/ag-grid-loading-spinner.svg) center / contain no-repeat; margin: 0 auto;"
></div>
<div aria-live="polite" aria-atomic="true">{{ loadingMessage() }}</div>
</div>
`,
})
export class CustomLoadingOverlay implements ILoadingOverlayAngularComp {
loadingMessage = signal('');
agInit(params: CustomLoadingOverlayParams): void {
this.refresh(params);
}
refresh(params: CustomLoadingOverlayParams): void {
this.loadingMessage.set(params.loadingMessage);
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Custom No Rows Overlay Copy Link
The no-rows overlay can be customised via the grid properties overlayNoRowsTemplate or noRowsOverlayComponent and noRowsOverlayComponentParams.
Provide a HTML string to override the default no-rows overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom no-rows overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the no-rows overlay component. overlayComponentParams |
Implement this interface to provide a custom overlay when no-rows loaded.
interface INoRowsOverlayAngularComp {
// Mandatory - Params for rendering this component.
agInit(params: INoRowsOverlayParams): void;
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom no-rows overlay component customised via parameters.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
import { CustomNoRowsOverlay } from "./custom-no-rows-overlay.component";
interface IAthlete {
athlete: string;
country: string;
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomNoRowsOverlay],
template: `<div class="example-wrapper">
<div>
<button (click)="onBtnClearRowData()">Clear rowData</button>
<button (click)="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[noRowsOverlayComponent]="noRowsOverlayComponent"
[noRowsOverlayComponentParams]="noRowsOverlayComponentParams"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IAthlete>;
columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
rowData: IAthlete[] | null = [];
noRowsOverlayComponent: any = CustomNoRowsOverlay;
noRowsOverlayComponentParams: any = {
noRowsMessageFunc: () =>
"No rows found at: " + new Date().toLocaleTimeString(),
};
onBtnClearRowData() {
this.gridApi.setGridOption("rowData", []);
}
onBtnSetRowData() {
this.gridApi.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
onGridReady(params: GridReadyEvent<IAthlete>) {
this.gridApi = params.api;
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
.fa-frown {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { INoRowsOverlayAngularComp } from 'ag-grid-angular';
import type { INoRowsOverlayParams } from 'ag-grid-community';
type CustomNoRowsOverlayParams = INoRowsOverlayParams & { noRowsMessageFunc: () => string };
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: ` <div class="overlay-loading-center" style="background-color: #b4bebe;" role="presentation">
<i class="far fa-frown" aria-live="polite" aria-atomic="true"> {{ noRowsMessage() }} </i>
</div>`,
})
export class CustomNoRowsOverlay implements INoRowsOverlayAngularComp {
noRowsMessage = signal('');
agInit(params: CustomNoRowsOverlayParams): void {
this.refresh(params);
}
refresh(params: CustomNoRowsOverlayParams): void {
this.noRowsMessage.set(params.noRowsMessageFunc());
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});

Overlays are used for displaying messages over the top of the grid. There are two built-in overlays: loading and no-rows.
This page documents the legacy approach to handling overlays. For the latest documentation, see Overlays Overview.
Loading overlay Copy Link
Show or hide the loading overlay by setting the loading property to true or false.
Show or hide the loading UI. true: the loading overlay is shown, or skeleton rows if loadingRows is enabled (Client-Side Row Model only). false: the loading UI is hidden. undefined: the grid will automatically show the loading overlay until rowData and columnDefs are provided. (Client Side Row Model only) |
The loading overlay takes precedence over the no-rows overlay and is not dependent of the state of rowData.
'use client';
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";
import {
ClientSideRowModelModule,
enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
interface IAthlete {
athlete: string;
country: string;
}
const columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 200 },
{ field: "country", minWidth: 200 },
];
const GridExample = () => {
const [loading, setLoading] = useState(true);
const [rowData, setRowData] = useState<IAthlete[] | undefined>();
return (
<AgGridProvider modules={modules}>
<div className="example-wrapper">
<div>
<label className="checkbox">
<input
type="checkbox"
onChange={(e) => setLoading(e.target.checked)}
checked={loading}
/>
loading
</label>
<button onClick={() => setRowData([])}>Clear rowData</button>
<button
onClick={() =>
setRowData([{ athlete: "Michael Phelps", country: "US" }])
}
>
Set rowData
</button>
</div>
<div style={{ height: "100%" }}>
<AgGridReact
loading={loading}
rowData={rowData}
columnDefs={columnDefs}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
label.checkbox {
display: inline-block;
user-select: none;
margin: 20px;
}
No rows overlay Copy Link
When rowData is set to an empty array [], the grid automatically displays the no-rows overlay. The no-rows overlay can also be programmatically shown / hidden via the grid API.
It is recommended to use the Active Overlay to manually display an overlay.
Show the no-rows overlay. If loading is true, this will not do anything.setGridOption('activeOverlay', 'agNoRowsOverlay') . |
Hide the no-rows overlay if it is showing. setGridOption('activeOverlay', undefined) . |
The automatic displaying of the no-rows overlay can be suppressed by setting suppressNoRowsOverlay to true.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
interface IAthlete {
athlete: string;
country: string;
}
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IAthlete[]>([]);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
]);
const onBtnClearRowData = useCallback(() => {
setRowData([]);
}, []);
const onBtnSetRowData = useCallback(() => {
setRowData([{ athlete: "Michael Phelps", country: "US" }]);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div>
<button onClick={onBtnClearRowData}>Clear rowData</button>
<button onClick={onBtnSetRowData}>Set rowData</button>
</div>
<div style={gridStyle}>
<AgGridReact<IAthlete> rowData={rowData} columnDefs={columnDefs} />
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
Initial loading overlay Copy Link
If loading is not explicitly defined, the grid will automatically show the loading overlay until both rowData and columnDefs are provided with a non-null value for the first time. This behaviour can be suppressed by initialising the grid with an appropriate loading state.
Customisation Copy Link
Overlays can be customised by providing either a HTML string or custom component via grid properties.
Custom Loading Overlay Copy Link
The loading overlay can be customised via the grid properties overlayLoadingTemplate or loadingOverlayComponent and loadingOverlayComponentParams.
Provide a HTML string to override the default loading overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom loading overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the loading overlay component. overlayComponentParams |
This example demonstrates how to provide a custom loading overlay component customised via parameters.
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import {
ClientSideRowModelModule,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import type { ColDef } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import CustomLoadingOverlay from "./customLoadingOverlay";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [TextEditorModule, TextFilterModule, ClientSideRowModelModule];
interface IAthlete {
athlete: string;
country: string;
}
const columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
const rowData: IAthlete[] = [
{ athlete: "Michael Phelps", country: "United States" },
{ athlete: "Natalie Coughlin", country: "United States" },
{ athlete: "Aleksey Nemov", country: "Russia" },
{ athlete: "Alicia Coutts", country: "Australia" },
];
const defaultColDef: ColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
const GridExample = () => {
const [loading, setLoading] = useState(true);
const loadingOverlayComponentParams = useMemo(() => {
return { loadingMessage: "One moment please..." };
}, []);
return (
<AgGridProvider modules={modules}>
<div className="example-wrapper">
<div>
<label className="checkbox">
<input
type="checkbox"
onChange={(e) => setLoading(e.target.checked)}
checked={loading}
/>
loading
</label>
</div>
<div style={{ height: "100%", width: "100%" }}>
<AgGridReact<IAthlete>
loading={loading}
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
loadingOverlayComponent={CustomLoadingOverlay}
loadingOverlayComponentParams={loadingOverlayComponentParams}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
label.checkbox {
display: inline-block;
user-select: none;
margin: 20px;
}
.fa-hourglass-half {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import React from "react";
import type { CustomLoadingOverlayProps } from "ag-grid-react";
export default (
props: CustomLoadingOverlayProps & { loadingMessage: string },
) => {
return (
<div className="overlay-loading-center" role="presentation">
<div
role="presentation"
className="custom-loading-overlay"
style={{
height: 100,
width: 100,
background:
"url(https://www.ag-grid.com/images/ag-grid-loading-spinner.svg) center / contain no-repeat",
margin: "0 auto",
}}
></div>
<div aria-live="polite" aria-atomic="true">
{props.loadingMessage}
</div>
</div>
);
};
Custom No Rows Overlay Copy Link
The no-rows overlay can be customised via the grid properties overlayNoRowsTemplate or noRowsOverlayComponent and noRowsOverlayComponentParams.
Provide a HTML string to override the default no-rows overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom no-rows overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the no-rows overlay component. overlayComponentParams |
This example demonstrates how to provide a custom no-rows overlay component customised via parameters.
'use client';
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";
import type { ColDef } from "ag-grid-community";
import {
ClientSideRowModelModule,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import CustomNoRowsOverlay from "./customNoRowsOverlay";
import "./styles.css";
interface IAthlete {
athlete: string;
country: string;
}
const columnDefs: ColDef[] = [
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
];
const defaultColDef = {
editable: true,
flex: 1,
minWidth: 100,
filter: true,
};
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [TextEditorModule, TextFilterModule, ClientSideRowModelModule];
const GridExample = () => {
const [rowData, setRowData] = useState<IAthlete[]>([]);
const noRowsOverlayComponentParams = useMemo(() => {
return {
noRowsMessageFunc: () =>
"No rows found at: " + new Date().toLocaleTimeString(),
};
}, []);
return (
<AgGridProvider modules={modules}>
<div className="example-wrapper">
<div>
<button onClick={() => setRowData([])}>Clear rowData</button>
<button
onClick={() =>
setRowData([{ athlete: "Michael Phelps", country: "US" }])
}
>
Set rowData
</button>
</div>
<div style={{ height: "100%" }}>
<AgGridReact<IAthlete>
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
noRowsOverlayComponent={CustomNoRowsOverlay}
noRowsOverlayComponentParams={noRowsOverlayComponentParams}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
.fa-frown {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
import React from "react";
import type { CustomNoRowsOverlayProps } from "ag-grid-react";
export default (
props: CustomNoRowsOverlayProps & { noRowsMessageFunc: () => string },
) => {
return (
<div
role="presentation"
className="overlay-loading-center"
style={{ backgroundColor: "#b4bebe", height: "9%" }}
>
<i className="far fa-frown" aria-live="polite" aria-atomic="true">
{" "}
{props.noRowsMessageFunc()}
</i>
</div>
);
};

Overlays are used for displaying messages over the top of the grid. There are two built-in overlays: loading and no-rows.
This page documents the legacy approach to handling overlays. For the latest documentation, see Overlays Overview.
Loading overlay Copy Link
Show or hide the loading overlay by setting the loading property to true or false.
Show or hide the loading UI. true: the loading overlay is shown, or skeleton rows if loadingRows is enabled (Client-Side Row Model only). false: the loading UI is hidden. undefined: the grid will automatically show the loading overlay until rowData and columnDefs are provided. (Client Side Row Model only) |
The loading overlay takes precedence over the no-rows overlay and is not dependent of the state of rowData.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div>
<label class="checkbox">
<input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
loading
</label>
<button v-on:click="onBtnClearRowData()">Clear rowData</button>
<button v-on:click="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:loading="true"
:columnDefs="columnDefs"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
]);
const rowData = ref<IAthlete[]>(null);
function setLoading(value: boolean) {
gridApi.value!.setGridOption("loading", value);
}
function onBtnClearRowData() {
gridApi.value!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi.value!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
rowData,
onGridReady,
setLoading,
onBtnClearRowData,
onBtnSetRowData,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
No rows overlay Copy Link
When rowData is set to an empty array [], the grid automatically displays the no-rows overlay. The no-rows overlay can also be programmatically shown / hidden via the grid API.
It is recommended to use the Active Overlay to manually display an overlay.
Show the no-rows overlay. If loading is true, this will not do anything.setGridOption('activeOverlay', 'agNoRowsOverlay') . |
Hide the no-rows overlay if it is showing. setGridOption('activeOverlay', undefined) . |
The automatic displaying of the no-rows overlay can be suppressed by setting suppressNoRowsOverlay to true.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
interface IAthlete {
athlete: string;
country: string;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div>
<button v-on:click="onBtnClearRowData()">Clear rowData</button>
<button v-on:click="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:rowData="rowData"
:columnDefs="columnDefs"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
const rowData = ref<IAthlete[] | null>([]);
const columnDefs = ref<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
]);
function onBtnClearRowData() {
gridApi.value!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi.value!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
rowData,
columnDefs,
onGridReady,
onBtnClearRowData,
onBtnSetRowData,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
Initial loading overlay Copy Link
If loading is not explicitly defined, the grid will automatically show the loading overlay until both rowData and columnDefs are provided with a non-null value for the first time. This behaviour can be suppressed by initialising the grid with an appropriate loading state.
Customisation Copy Link
Overlays can be customised by providing either a HTML string or custom component via grid properties.
Custom Loading Overlay Copy Link
The loading overlay can be customised via the grid properties overlayLoadingTemplate or loadingOverlayComponent and loadingOverlayComponentParams.
Provide a HTML string to override the default loading overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom loading overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the loading overlay component. overlayComponentParams |
Any valid Vue component can be a loading overlay component, however it is also possible to implement the following optional methods:
interface ILoadingOverlay<TData = any, TContext = any> {
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom loading overlay component customised via parameters.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomLoadingOverlay from "./customLoadingOverlayVue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
interface IAthlete {
athlete: string;
country: string;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div>
<label class="checkbox">
<input type="checkbox" checked="" v-on:change="setLoading($event.currentTarget.checked)">
loading
</label>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:rowData="rowData"
:defaultColDef="defaultColDef"
:loading="true"
:loadingOverlayComponent="loadingOverlayComponent"
:loadingOverlayComponentParams="loadingOverlayComponentParams"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomLoadingOverlay,
},
setup(props) {
const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
]);
const rowData = ref<IAthlete[] | null>([
{ athlete: "Michael Phelps", country: "United States" },
{ athlete: "Natalie Coughlin", country: "United States" },
{ athlete: "Aleksey Nemov", country: "Russia" },
{ athlete: "Alicia Coutts", country: "Australia" },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
filter: true,
});
const loadingOverlayComponent = ref("CustomLoadingOverlay");
const loadingOverlayComponentParams = ref({
loadingMessage: "One moment please...",
});
function setLoading(value: boolean) {
gridApi.value!.setGridOption("loading", value);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
rowData,
defaultColDef,
loadingOverlayComponent,
loadingOverlayComponentParams,
onGridReady,
setLoading,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
label.checkbox {
display: inline-block;
user-select: none;
margin: 20px;
}
.fa-hourglass-half {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
export default {
template: `
<div class="overlay-loading-center" role="presentation">
<div role="presentation" style="height:100px; width:100px; background: url(https://www.ag-grid.com/images/ag-grid-loading-spinner.svg) center / contain no-repeat; margin: 0 auto"></div>
<div aria-live="polite" aria-atomic="true">{{params.loadingMessage}}</div>
</div>`,
};
Custom No Rows Overlay Copy Link
The no-rows overlay can be customised via the grid properties overlayNoRowsTemplate or noRowsOverlayComponent and noRowsOverlayComponentParams.
Provide a HTML string to override the default no-rows overlay. Supports non-empty plain text or HTML with a single root element. overlayComponent / overlayComponentSelector |
Provide a custom no-rows overlay component. overlayComponent / overlayComponentSelector |
Customise the parameters provided to the no-rows overlay component. overlayComponentParams |
Any valid Vue component can be a no-rows overlay component, however it is also possible to implement the following optional methods:
interface INoRowsOverlay<TData = any, TContext = any> {
// Gets called when the `overlayComponentParams` grid option is updated
refresh?(params: TParams): void;
}This example demonstrates how to provide a custom no-rows overlay component customised via parameters.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomNoRowsOverlay from "./customNoRowsOverlayVue";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
TextFilterModule,
ClientSideRowModelModule,
]);
interface IAthlete {
athlete: string;
country: string;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div>
<button v-on:click="onBtnClearRowData()">Clear rowData</button>
<button v-on:click="onBtnSetRowData()">Set rowData</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:noRowsOverlayComponent="noRowsOverlayComponent"
:noRowsOverlayComponentParams="noRowsOverlayComponentParams"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomNoRowsOverlay,
},
setup(props) {
const gridApi = shallowRef<GridApi<IAthlete> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", width: 150 },
{ field: "country", width: 120 },
]);
const defaultColDef = ref<ColDef>({
editable: true,
flex: 1,
minWidth: 100,
filter: true,
});
const rowData = ref<IAthlete[] | null>([]);
const noRowsOverlayComponent = ref("CustomNoRowsOverlay");
const noRowsOverlayComponentParams = ref({
noRowsMessageFunc: () =>
"No rows found at: " + new Date().toLocaleTimeString(),
});
function onBtnClearRowData() {
gridApi.value!.setGridOption("rowData", []);
}
function onBtnSetRowData() {
gridApi.value!.setGridOption("rowData", [
{ athlete: "Michael Phelps", country: "US" },
]);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
noRowsOverlayComponent,
noRowsOverlayComponentParams,
onGridReady,
onBtnClearRowData,
onBtnSetRowData,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
}
.fa-frown {
color: navy;
font-size: 18px;
}
.overlay-loading-center {
background: var(--ag-background-color);
border: solid var(--ag-border-width) var(--ag-border-color);
border-radius: var(--ag-border-radius);
box-shadow: var(--ag-popup-shadow);
padding: var(--ag-spacing);
}
export default {
template: `
<div role="presentation" class="overlay-loading-center" style="background-color: #b4bebe;">
<i class="far fa-frown" aria-live="polite" aria-atomic="true"> {{params.noRowsMessageFunc()}}</i>
</div>
`,
};